//=============================================================================
// QLKeyClone.
//
// Author: Francesco Biscazzo
// Date: 2016
//=============================================================================
class QLKeyClone extends TournamentPickup;

var() String Events[10], ZoneNames[10];

function bool HandlePickupQuery( Inventory item ) {
	local int i, j;
	local Inventory nextInv;
	local bool bNewAccessFound;
	
	if (item.IsA('QLKeyClone')) {
		for (i = 0; i < 10; i++) { //item Events/ZoneNames slots.
			bNewAccessFound = false;
			
			if (QLKeyClone(item).Events[i] != "") {
				nextInv = Owner.Inventory;
				while (nextInv != none) { //Iterate through the already owned keys.
					if (nextInv.IsA('QLKeyClone')) {
						Level.Game.BroadcastMessage(1@item@nextInv);
						for (j = 0; j < 10; j++) { //nextInv Events slots.
							if (QLKeyClone(nextInv).Events[j] != "") {
								if (QLKeyClone(item).Events[i] != QLKeyClone(nextInv).Events[j]) {
									bNewAccessFound = true;
									Level.Game.BroadcastMessage(1@QLKeyClone(item).Events[i]@QLKeyClone(nextInv).Events[j]);
								}
							}
						}
					}
					
					nextInv = nextInv.Inventory;
				}
			}
			
			if (!bNewAccessFound) {
				if (QLKeyClone(item).ZoneNames[i] != "") {
					nextInv = Owner.Inventory;
					while (nextInv != none) { //Iterate through the already owned keys.
						if (nextInv.IsA('QLKeyClone')) {
							Level.Game.BroadcastMessage(2@item@nextInv);
							for (j = 0; j < 10; j++) { //nextInv ZoneNames slots.
								if (QLKeyClone(nextInv).ZoneNames[j] != "") {
									if (QLKeyClone(item).ZoneNames[i] != QLKeyClone(nextInv).ZoneNames[j]) {
										bNewAccessFound = true;
										Level.Game.BroadcastMessage(2@QLKeyClone(item).ZoneNames[i]@QLKeyClone(nextInv).ZoneNames[j]);
									}
								}
							}
						}
						
						nextInv = nextInv.Inventory;
					}
				}
			}
			
			if (bNewAccessFound) {
				Level.Game.BroadcastMessage(bNewAccessFound);
				return Inventory.HandlePickupQuery(item);
			}
		}
		
		Level.Game.BroadcastMessage(bNewAccessFound);
		return true;
	}
	
	Level.Game.BroadcastMessage("end");
	return Inventory.HandlePickupQuery(item);
}

function SetRespawn()
{
	GotoState('Sleeping');
}

function Inventory SpawnCopy( pawn Other ) {
	local QLKeyClone Copy, newKey;
	local int i;

	Copy = spawn(Class,Other,,,rot(0,0,0));
	Copy.Tag = Tag;
	Copy.Event = Event;
	
	for (i = 0; i < 10; i++) {
		Copy.Events[i] = Events[i];
		Copy.ZoneNames[i] = ZoneNames[i];
	}
	
	GotoState('Sleeping');
	Copy.RespawnTime = 0.0;
	Copy.bHeldItem = true;
	Copy.GiveTo( Other );
	
	newKey = Copy;
	newKey.Instigator = Other;
	
	return newKey;
}

state Activated
{
	function Activate() {
		bActive = true;
	}

	function EndState() {
		bActive = false;
		GotoState('Idle2');
	}

	function BeginState() {
		bActive = true;
	}
}

defaultproperties (
	bCanHaveMultipleCopies=true
	bAutoActivate=true
	bInstantRespawn=true
	DrawType=DT_Sprite
	Texture=Texture'Engine.S_Keypoint'
)